#include <stdio.h>

typedef enum {backward,forward} State_link_type;
typedef struct path_rec {

         char id;
         struct path_rec *next;
} *path_type;

typedef struct loop_rec {

         char loop[200];
         struct loop_rec *next;
} *loops_type;

typedef struct st_type {

         char  id;
         State_link_type type;
         int counter;
} State_Type;

typedef struct list_type {

         char  id;
         int   outdegree;
         char  elements[20];
} adj_list_type;

void read_input(void);
void Find_All_Easy_Paths(State_Type S);
void Find_Loop_Paths(State_Type S);
void add_current_state( char id);
int equal_size(int i, int j);
int same_states(int i, int j);
int is_already_in_path(char id);
int there_is_a_match(char paths[100][200],int m,char ch);
int is_already_in_process_list(char id);
int is_aloop(void);
int lookup_adj(char id);
int all_adj_in_loop(char id);
void append_new_loops(char id);
void remove_last_element(void );
int in_final_states(char id);
int Find_index(char id);
int are_mutual_adj(char id1,char id2);
int i_adjto_j(char idi,char idj);
int ends_equal(char loop[200]);
int insertion_allowed(char t[200],loops_type l,int *p);
int loop_matched(int i,char loop[200],int m);  
void add_path(void);
void find_loop_mutation(void);
void add_loop_path(void);
void print_Results(void);
void print_Results2(void);
void print_Results3(int ind);
void merge_thread_loop(char thread[200]);
void insert_loop(char t[200],loops_type l, int pos[20],int o);
void add_mut_loop(int i, int j, char t[200], char l[200], int loc[100], int occ,int flg);
void add_mut_loop1(int i, int j, char t[200], char l[200], int loc[100], int occ,int flg);
void add_new_loops(char t[200], int ind);
void add_more_loops(int i, int j);
void add_new_thread(char t[200]);


adj_list_type adj_list[100];

int  del_size,del_loop[10],num_of_states=0,FinalIndex=0,Final_Found = 0, 
     got_it,ss,m,k,loop_path_index=0,path_index =0,process_list_size=0;

char loop_paths[100][200],paths[100][200], Finals[20],Process_list[50];

path_type  test_path=(struct path_rec *) 0;

loops_type  loops_mutat[100];

State_Type State;
FILE *inp,*out;

main()
{

 loops_type  curr;
 int i,j,temp_index,num_of_occ,locations[100];
 char temp_thread[200],in_name[20],out_name[20];

 printf("Please Enter the input File Name:\n");
 scanf("%s",in_name);
 inp = fopen(in_name,"r");
 printf("Please Enter the output File Name:\n");
 scanf("%s",out_name);
 out = fopen(out_name,"w");
 for (i=0; i< 100; i++)
   for (j=0; j < 200; j++)
   {
     paths[i][j] = ' ';
     loop_paths[i][j] = ' ';
   }
 for (i=0; i< 100; i++)
   loops_mutat[i]=(struct loop_rec *) 0;
 read_input();
 State.id = adj_list[0].id;
 State.type = forward;
 State.counter = 1;
 Find_All_Easy_Paths(State);
 fprintf(out,"The easy paths are:-\n");
 print_Results();
 for (i=0; i < process_list_size;i++)
 {

   test_path=(struct path_rec *) 0;
   State.id=Process_list[i];
   State.type = forward;
   State.counter = 1;
   Find_Loop_Paths(State);
 }
 del_size = -1;
 for (i=0; i < loop_path_index; i++)
   for (j=0; j <loop_path_index; j++)
   {
     if (i != j)
     {
        if ((equal_size(i,j)==1) && (same_states(i,j)==1))
        {
           m = -1;
           if (are_mutual_adj(loop_paths[i][0],loop_paths[j][0])==0)
             if (i_adjto_j(loop_paths[i][0],loop_paths[j][0])==1)
               m= j;
             else 
               m= i;
           else
           {
             if (Find_index(loop_paths[i][0])<Find_index(loop_paths[j][0]))
               m = j;
             else
               m=i;
           }
           if (del_size > -1)
           {
              got_it = 0;
              for(ss=0; ((!got_it) && (ss <= del_size)); ss++)
                if (m == del_loop[ss])
                  got_it = 1;
              if (!got_it)
              {
                ++del_size;
                del_loop[del_size] = m;
              }
           }
           else
           {
              if (m > -1)
              {
                ++del_size;
                del_loop[del_size] = m;
              }
           }
         }

     }
   }

 if (del_size > -1)
 {
   for (i=del_size; i > -1; i--)
   {
     for (j = del_loop[i]; j < loop_path_index; j++)
       for (k=0; k < 200; k++)
         loop_paths[j][k] = loop_paths[j+1][k];
     --loop_path_index;
   }
 }
 fprintf(out,"\n\nThe loop paths are:-\n");
 print_Results2();

 find_loop_mutation();

 temp_index = path_index;
 for (i=0; i < temp_index; i++)
 {
    for (j=0; j<200;j++)
      temp_thread[j] = paths[i][j]; 
    merge_thread_loop(temp_thread);
 }

 fprintf(out,"\n\nThe rest of the test paths are:\n");
 print_Results3(temp_index); 
 
 fclose(inp);
 fclose(out);

}
         
void read_input()
{

  int ind,ind1,adj_cntr;
  char ch;

  fscanf(inp,"%d\n",&FinalIndex);
  fprintf(out,"the final states are :- ",FinalIndex);
  for (ind = 0; ind < FinalIndex; ind++)
  {
     fscanf(inp,"%c\n",&ch);
     fprintf(out,"%c ",ch);
     Finals[ind] = ch;
  } 
  fprintf(out,"\n\n the states and their corresponding adjacent lists are :-\n");
  ind = 0;
  fscanf(inp,"%c\n",&ch);
  while (ch != '*')
  {
    fprintf(out,"%c ->",ch);
    adj_list[ind].id = ch; 
    fscanf(inp,"%d\n",&adj_cntr);
    adj_list[ind].outdegree = adj_cntr;
    for (ind1=0;ind1 < adj_cntr;ind1++)
    {
       fscanf(inp,"%c\n",&ch);
       fprintf(out,"%c ",ch);
       adj_list[ind].elements[ind1] = ch;
    }
    fprintf(out,"\n ");
    fscanf(inp,"%c\n",&ch);
    if (ch != '*') 
      ++ind;
  }
  num_of_states = ind +1;
}


void Find_All_Easy_Paths(State)
State_Type State;
{

  int StateInd,count_paths;
  State_Type temp_state;
  char adj_state_object;

  add_current_state(State.id);

  if (in_final_states(State.id))
  {
    add_path();
    Final_Found = 1;
    ++path_index;
  }

    count_paths = 0;
    StateInd = Find_index(State.id);    
    while (State.counter <= adj_list[StateInd].outdegree) 
    {
      adj_state_object = adj_list[StateInd].elements[State.counter-1];
      if (is_already_in_path(adj_state_object)==0)
      {
        temp_state.id = adj_state_object;
        temp_state.type = forward;
        temp_state.counter = 1;
        Find_All_Easy_Paths(temp_state);
        if (Final_Found)
        {
          ++count_paths;
          Final_Found = 0; 
        }
      }
      State.counter++;
    }
   
    if (count_paths > 0)
      Final_Found = 1;
    if (((count_paths > 0) && (count_paths < adj_list[StateInd].outdegree)) ||
        ((in_final_states(State.id)) && (count_paths < adj_list[StateInd].outdegree)))
    {
     if (is_already_in_process_list(State.id) ==0) 
     {
        Process_list[process_list_size]= State.id;
        ++process_list_size;
     }
    }
  remove_last_element();
}

void Find_Loop_Paths(State)
State_Type State;
{

  int m,StateInd,I, list_size;
  State_Type temp_state;
  char adj_state_object,curr_adj_list[20],temp_ch;
  path_type  temp_path=(struct path_rec *) 0;

  
  add_current_state(State.id);

  for (I=0; I < 20; I ++)
    curr_adj_list[I] = ' ';

  list_size = 0;
  StateInd = Find_index(State.id);    
  while (State.counter <= adj_list[StateInd].outdegree) 
  {
      adj_state_object = adj_list[StateInd].elements[State.counter-1];
      if ((State.type == forward) || (lookup_adj(adj_state_object) ==0) || (is_already_in_path(adj_state_object)==0))
      {
          curr_adj_list[list_size]= adj_state_object; 
          ++list_size;
      }
      State.counter++;
  }

  if (is_aloop()==1)
  {
    if (State.id == test_path->id)
    {
      add_loop_path();
      ++loop_path_index;
    }
    else
    {
      if (are_mutual_adj(State.id,test_path->id)==1)
      {
        temp_path=test_path; 
        test_path = test_path->next;
        add_loop_path();
        ++loop_path_index;
        test_path = temp_path;
      }
    }
  }
  else
  {
    I = 0;
    while (I < list_size) 
    {
        temp_state.id = curr_adj_list[I];
        temp_state.counter = 1;
        if (is_already_in_path(curr_adj_list[I])==1)
          temp_state.type = backward;
        else 
          temp_state.type = forward;
        Find_Loop_Paths(temp_state); 
      I++;
     }
  } 
  remove_last_element();
}

int lookup_adj(id)
char id;
{

  int i,id_index,result = 1;
  char  adj_obj;
  
  id_index = Find_index(id);    

  for (i=1 ; i <= adj_list[id_index].outdegree; i++)
  {
    adj_obj = adj_list[id_index].elements[i-1];
    if (is_already_in_path(adj_obj)==0)
      result = 0;
  }

  return result;
}
void add_current_state(id)
char id;
{
  
   path_type curr, new_item;

   if (test_path == (struct path_rec *) 0)
   {

     test_path = (path_type) malloc(sizeof(struct path_rec));     
     test_path->id = id;
     test_path->next = (struct path_rec *) 0;
   }

   else 

   {
     new_item = (path_type) malloc(sizeof(struct path_rec));
     new_item->id = id;
     new_item->next = (struct path_rec *) 0;
     curr = test_path;

     while (curr->next != (struct path_rec *) 0) 
       curr= curr->next;
     curr->next = new_item;
   }
}

int is_already_in_path(id)
char id;
{

  int flag = 0;
  path_type curr=test_path;

  while ((flag ==0) && (curr != (struct path_rec *) 0))
  {
    if (curr->id == id)
      flag = 1;
    curr = curr->next;
  }
  return flag;
} 
      
void remove_last_element()
{
  path_type prev,curr;

  if (test_path->next == (struct path_rec *) 0)
  {
    free(test_path);
    return;
   }
  curr = test_path;
  while (curr->next != (struct path_rec *) 0)
  {

    prev = curr;
    curr = curr->next;
  }

  prev->next = (struct path_rec *) 0;
  free(curr);
}

int in_final_states(id)
char id;
{

   int i,flag=0;

   for (i=0; ((i < FinalIndex) && (flag==0)); i++)
     if (Finals[i] == id)
       flag = 1;
   return (flag);
} 

int Find_index(id)
char id;
{

  int i;

  for (i=0; ((i < num_of_states) && (adj_list[i].id != id)); i++);
  return i;
} 


void add_path()
{

  int i;
  path_type curr;

  curr = test_path;

  for (i=0; curr != (struct path_rec *) 0; i++)
  {
    paths[path_index][i] = curr->id;
    curr = curr->next;
  }
}

void add_loop_path()
{

  int i;
  path_type curr;

  curr = test_path;

  for (i=0; curr != (struct path_rec *) 0; i++)
  {
    loop_paths[loop_path_index][i] = curr->id;
    curr = curr->next;
  }

}



void print_Results()
{

  int i,j;

  for (i=0; i < path_index; i++)
  {
    for (j=0; ((j < 200) && (paths[i][j] !=' ')) ; j++)
       fprintf(out,"%c ",paths[i][j]);
    fprintf(out,"\n");
  }
}
void print_Results2()
{

  int i,j;

  for (i=0; i < loop_path_index; i++)
  {
    for (j=0; ((j < 200) && (loop_paths[i][j] !='\0')) ; j++)
       fprintf(out,"%c ",loop_paths[i][j]);
    fprintf(out,"\n");
  }
}

void print_Results3(ind)
int ind;
{

  int i,j;

  for (i=ind; i < path_index; i++)
  {
    for (j=0; ((j < 200) && (paths[i][j] !=' ')) ; j++)
       fprintf(out,"%c ",paths[i][j]);
    fprintf(out,"\n");
  }
}
     
int is_aloop()
{

  int res=0;
  path_type curr=test_path,curr1;
  
     
  while (curr != (struct path_rec *)0)
  {
    curr1 = curr->next;
    while (curr1 != (struct path_rec *)0)
    {
      if ( curr->id == curr1->id)
        res = 1;
      curr1 = curr1->next;
    } 
    curr = curr->next;
  }
  return res;
}

int is_already_in_process_list (ch)
char ch;
{

   int i,result=0;

   for (i=0; i<process_list_size; i++)
   {
      if (ch == Process_list[i])
        result = 1;
   }
   return result;
}
int there_is_a_match( paths, m, ch)
char paths[100][200];
int m;
char ch;
{

  int i,res=0;

  for (i=0; (paths[m][i] != ' ') ;i++)
    if (ch == paths[m][i])
      res=1;
  return res;
}
int all_adj_in_loop(id)
char id;
{
  int res=1,id_index,loop_flag,i,j;

  id_index=Find_index(id);
  for (i=0;i< adj_list[id_index].outdegree;i++)
  {
    loop_flag = 0;
    for (j=0; j < process_list_size; j++)
    {
       if (Process_list[j] == adj_list[id_index].elements[i]) 
         loop_flag = 1;
    }
    if (loop_flag ==0) res = 0;
  }
  if (adj_list[id_index].outdegree ==1)
    res = 0;

  return res;
}
void append_new_loops(id)
char id;
{
  int id_index,i,j;

  id_index=Find_index(id);
  for (i=0;i< adj_list[id_index].outdegree;i++)
  {
    for (j=0; j < adj_list[id_index].outdegree;j++)

      if (i!=j) {
        loop_paths[loop_path_index][0]=adj_list[id_index].elements[i];
        loop_paths[loop_path_index][1]=id;
        loop_paths[loop_path_index][2]=adj_list[id_index].elements[j];
        loop_paths[loop_path_index][3]= '\0';
        ++loop_path_index;
      }
  }
     

}

int are_mutual_adj(id1,id2)
char id1;
char id2;
{
  int id_index,i,j,res1=0,res2=0,res=0;

  id_index=Find_index(id1);
  for (i=0;i< adj_list[id_index].outdegree;i++)
    if (adj_list[id_index].elements[i] == id2)
      res1 = 1;
  id_index=Find_index(id2);
  for (i=0;i< adj_list[id_index].outdegree;i++)
    if (adj_list[id_index].elements[i] == id1)
      res2 = 1;
  if ((res1==1) && (res2==1))
    res = 1;

  return res;
}


void merge_thread_loop(thread)
char thread[200];
{

  int i,j,lk,m,loc[20],k,ind,occ;
  char tmp_thrd[200];

  for (i=0; i< loop_path_index; i++)
  {
    occ = -1;
    j = 0;
    while (thread[j] != ' ')
    {
      if (thread[j] == loop_paths[i][0])
      {
        m = j;
        if (insertion_allowed(thread,loops_mutat[i],&j)==1)
        {
          ++occ;
          loc[occ] = m;
          ++j;
        }
        else  { ++j;}
      }
      else ++j;
    }
    if (occ > -1)
    {
      ind = path_index;
      insert_loop(thread,loops_mutat[i],loc,occ);
      for (k=ind; k < path_index; k++)
      {
        for (lk=0;lk < 200;lk++)
          tmp_thrd[lk] = ' ';

        for (lk=0;paths[k][lk] != ' ';lk++)
        {
          tmp_thrd[lk] = paths[k][lk];
        }
        merge_thread_loop(tmp_thrd); 
      }
    }
  }
} 
int insertion_allowed(t,l,p)
char t[200];
loops_type l;
int  *p;
{
  int i,j,d,allowed=1,equal,stop,sz=-1;
  loops_type curr;


  stop = 0;
  for (i=0,j=*p; ((l->loop[i] !=' ') && (t[j] != ' ') && (!stop));i++,j++)
    if ((l->loop[i] != ' ') && (l->loop[i] != t[j]))
      stop = 1;
  if ((l->loop[i] == ' ') && (!stop))  
  {
    allowed = 0;
    if (sz < i)
    {
      sz = i;
      ++j;
      d = j;
    }
  }
  else 
  { 
      curr=l;
      curr = curr->next; 
      equal = 0;
      while ((!equal) && (curr != (struct loop_rec *) 0))
      {
        stop = 0;
        for (i=0,j=*p; ((curr->loop[i] !=' ') && (t[j] != ' ') && (!stop));i++,j++)
          if ((curr->loop[i] != ' ') && (curr->loop[i] != t[j]))
            stop = 1;
        if ((curr->loop[i] == ' ') && (!stop))  
        {
          allowed = 0;
          equal = 1;
          if (sz < i)
          {
            sz = i;
            ++j;
            d = j;
          }
        }
        curr = curr->next; 
      } 
  } 
  if (allowed == 0) *p = d;
  return allowed;
}
void insert_loop(t,l,pos,o)
char t[200];
loops_type l;
int  pos[20];
int  o;
{
  int k,m,i,j,r,equal,stop;
  char tmp[200];
  
  if (o==0)
  {
    equal =0;
    for (i=0; ((!equal) && (i < path_index));i++)
    {
      stop = 0;
      for (j=0; ((!stop) && (t[j] != ' ') && (paths[i][j] != ' ')); j++)
        if ((t[j] != ' ') && (paths[i][j] != t[j]))
          stop = 1;
      if ((!stop) && (t[j] == ' ') && (paths[i][j] == ' '))
        equal =1;
    }
    r = pos[0];
    if (!equal)
        add_new_thread(t);
    r = pos[0];
    if (insertion_allowed(t,l,&r)==1)
    {
      for (m=0; m < 200; m++)
        tmp[m] = ' ';
      r = pos[0];
      for (m=r+1,j =0; t[m] !=' '; m++,j++)
        tmp[j] = t[m];
      r = pos[0];
      for (m=0,j=r; l->loop[m] != ' '; m++,j++)
        t[j] = l->loop[m];
      for (k=j,m=0; tmp[m] != ' '; k++,m++)
        t[k] = tmp[m];
      equal =0;
      for (i=0; ((!equal) && (i < path_index));i++)
      {
        stop = 0;
        for (j=0; ((!stop) && (t[j] != ' ') && (paths[i][j] != ' ')); j++)
          if ((t[j] != ' ') && (paths[i][j] != t[j]))
            stop = 1;
        if ((!stop) && (t[j] == ' ') && (paths[i][j] == ' '))
          equal =1;
      }
      if (!equal)
        add_new_thread(t);
      t[r] = l->loop[0];
      for (m=r+1,j=0; tmp[j] != ' '; m++,j++)
        t[m] = tmp[j];
      for (j=m; j<200;j++) 
        t[j] = ' ';
    } 
  }
  else
  {
    insert_loop(t,l,pos,o-1);
    r = pos[o];
    if (insertion_allowed(t,l,&r)==1)
    {
      for (m=0; m < 200; m++)
        tmp[m] = ' ';
      r = pos[o];
      for (m=r+1,j =0; t[m] !=' '; m++,j++)
        tmp[j] = t[m];
      r = pos[o];
      for (m=0,j=r; l->loop[m] != ' '; m++,j++)
        t[j] = l->loop[m];
      for (k=j,m=0; tmp[m] != ' '; k++,m++)
        t[k] = tmp[m];
      insert_loop(t,l,pos,o-1);
      t[r] = l->loop[0];
      for (m=r+1,j=0; tmp[j] != ' '; m++,j++)
        t[m] = tmp[j];
      for (j=m; j<200;j++) 
        t[j] = ' ';
    }  
  }
}
void find_loop_mutation()
{
  int set_n,i,j,m, locations[100], num_of_occ;

  for (i=0; i < loop_path_index; i++)
    add_new_loops(loop_paths[i],i);
  for (i=0; i < loop_path_index; i++)
  {
    set_n=0;
    for (j=0; j < loop_path_index; j++)
    {
       if (i !=j)
       {
         num_of_occ =-1;
         for (m=0; loop_paths[j][m] != ' '; m++)
           if (loop_paths[i][0] == loop_paths[j][m])  
           {
             ++num_of_occ;
             locations[num_of_occ]= m;
           }
        }
        if ((i !=j) && (num_of_occ > -1))
        {
          if ((loop_paths[i][0] == loop_paths[j][0]) ) 
          {
           add_mut_loop(i,j,loop_paths[i],loop_paths[j],locations,num_of_occ,1);
           add_mut_loop(j,i,loop_paths[i],loop_paths[j],locations,num_of_occ,0);
          }
          else if (loop_paths[i][0] != loop_paths[j][0])
          {
           add_mut_loop(i,j,loop_paths[i],loop_paths[j],locations,num_of_occ,1);
           add_mut_loop1(j,i,loop_paths[i],loop_paths[j],locations,num_of_occ,0);
           set_n=1;
          }
          if (set_n==1)
          {
           set_n=0;
           add_mut_loop(j,i,loop_paths[i],loop_paths[j],locations,num_of_occ,0);
          }
        }
     }
   }  
}

void add_mut_loop(i,f,s,t,l,occ,switch_flg)
int i;
int f;
char s[200];
char t[200];
int l[100];
int occ;
int switch_flg;
{

  int k,m,j,r,go,skip;
  char tmp[200];

  if (occ==0)
  {
    go=0;
    for(k=0; ((!go) && (k < loop_path_index));k++)
    {
      if (k != i)
      {
        skip = 0;
        for (j=0; ((!skip) && (t[j] != ' ') && (loops_mutat[k]->loop[j] !=' '));j++)
          if (loops_mutat[k]->loop[j] !=t[j])
            skip=1;
        if ((!skip) && (t[j]==' ') && (loops_mutat[k]->loop[j] ==' '))
        {
          go = 1;
        }
      }
    }
    if (!go)
      if (switch_flg)
        add_new_loops(t,f);
      else 
        add_new_loops(t,i); 
    for (m=0; m < 200; m++)
      tmp[m] = ' ';
    r = l[0];
    for (m=r+1,j =0; t[m] !=' '; m++,j++)
      tmp[j] = t[m];
    r = l[0];
    for (m=0,j=r; s[m] != ' '; m++,j++)
      t[j] = s[m];
    for (k=j,m=0; tmp[m] != ' '; k++,m++)
      t[k] = tmp[m];
    add_new_loops(t,i);
    t[r] = s[0];
    for (m=r+1,j=0; tmp[j] != ' '; m++,j++)
      t[m] = tmp[j];
    for (j=m; j<200;j++) 
      t[j] = ' ';
  }
  else
  {
    add_mut_loop(i,f,s,t,l,occ-1,switch_flg); 
    for (m=0; m < 200; m++)
      tmp[m] = ' ';
    for (m=(l[occ])+1,j =0; t[m] !=' '; m++,j++)
      tmp[j] = t[m];
    for (m=0,j=l[occ]; s[m] != ' '; m++,j++)
      t[j] = s[m];
    for (k=j,m=0; tmp[m] != ' '; k++,m++)
      t[k] = tmp[m];
    add_mut_loop(i,f,s,t,l,occ-1,switch_flg);
    t[l[occ]] = s[0];
    for (m=(l[occ])+1,j=0; tmp[j] != ' '; m++,j++)
      t[m] = tmp[j];
    for (j=m; j<200;j++) 
      t[j] = ' ';
  }
}

void add_mut_loop1(i,f,s,t,l,occ,switch_flg)
int i;
int f;
char s[200];
char t[200];
int l[100];
int occ;
int switch_flg;
{

  int k,m,j,r,go,skip;
  char tmp[200];

  if (occ==0)
  {
    go=0;
    for(k=0; ((!go) && (k < loop_path_index));k++)
    {
      if (k != i)
      {
        skip = 0;
        for (j=0; ((!skip) && (t[j] != ' ') && (loops_mutat[k]->loop[j] !=' '));j++)
          if (loops_mutat[k]->loop[j] !=t[j])
            skip=1;
        if ((!skip) && (t[j]==' ') && (loops_mutat[k]->loop[j] ==' '))
        {
          go = 1;
        }
      }
    }
    for (m=0; m < 200; m++)
      tmp[m] = ' ';
    r = l[0];
    for (m=r+1,j =0; t[m] !=' '; m++,j++)
      tmp[j] = t[m];
    r = l[0];
    for (m=0,j=r; s[m] != ' '; m++,j++)
      t[j] = s[m];
    for (k=j,m=0; tmp[m] != ' '; k++,m++)
      t[k] = tmp[m];
    add_new_loops(t,i);
    t[r] = s[0];
    for (m=r+1,j=0; tmp[j] != ' '; m++,j++)
      t[m] = tmp[j];
    for (j=m; j<200;j++) 
      t[j] = ' ';
  }
  else
  {
    for (m=0; m < 200; m++)
      tmp[m] = ' ';
    for (m=(l[occ])+1,j =0; t[m] !=' '; m++,j++)
      tmp[j] = t[m];
    for (m=0,j=l[occ]; s[m] != ' '; m++,j++)
      t[j] = s[m];
    for (k=j,m=0; tmp[m] != ' '; k++,m++)
      t[k] = tmp[m];
    add_mut_loop1(i,f,s,t,l,occ-1,switch_flg);
    t[l[occ]] = s[0];
    for (m=(l[occ])+1,j=0; tmp[j] != ' '; m++,j++)
      t[m] = tmp[j];
    for (j=m; j<200;j++) 
      t[j] = ' ';
  }
}

void add_new_loops(t,index)
char t[200];
int index;
{
  loops_type curr,new_loop;
  int j,i, stop, equal;

  if (loops_mutat[index] != (struct loop_rec *)0)
  {
    curr = loops_mutat[index];
    equal =0;
    while ((curr != (struct loop_rec *) 0) && (!equal))
    {
      stop = 0;
      for (i=0; ((curr->loop[i] != ' ') && (!stop));i++)
        if (t[i] != curr->loop[i])
          stop = 1;
      if ((!stop) && (curr->loop[i] ==' ') && (t[i] == ' '))
        equal = 1;
      else
        curr = curr->next;
    }
    if (!equal)
    {
      curr = loops_mutat[index];
      while (curr->next != (struct loop_rec *) 0) 
        curr = curr->next;
      new_loop = (loops_type) malloc(sizeof(struct loop_rec));
      for (i=0; t[i] != ' ';i++)
        new_loop->loop[i] = t[i];
      for (j=i; j< 200; j++)
        new_loop->loop[j] = ' ';
      new_loop->next = (struct loop_rec *)0;
      curr->next = new_loop;
    }
  }
  else
  {
    new_loop = (loops_type) malloc(sizeof(struct loop_rec));
    for (i=0; t[i] != ' '; i++)
      new_loop->loop[i] = t[i];
    for (j=i; j < 200; j++)
      new_loop->loop[j] = ' ';
    new_loop->next = (struct loop_rec *)0;
    loops_mutat[index] = new_loop;
  }
}

void add_new_thread(t)
char t[200];
{

  int i;

  for (i=0; (t[i] != ' '); i++)
  {
    paths[path_index][i] = t[i];
  }
  ++path_index;
}

int ends_equal(loop)
char loop[200];
{

  int i;

  for (i=0; loop[i] != ' '; i++);
  if (loop[0] == loop[i-1])
   return 1;
  else return 0;
}

void add_more_loops(i,j)
int i;
int j;
{

  loops_type curr;

  curr = loops_mutat[j];
  while (curr != (struct loop_rec *)0)
  {

    add_new_loops(curr->loop,i);
    curr = curr->next;
  }
}

int equal_size(i,j)
int i;
int j;
{
  int f,ff;

  for (f=0; loop_paths[i][f] != ' '; f++);
  for (ff=0; loop_paths[j][ff] != ' '; ff++);
  if (f == ff)
    return 1;
  else return 0;
} 
int same_states(i,j)
int i;
int j;
{

  int dd,ddd,stop,not_equal=0;
  for (dd=0; ((!not_equal) && (loop_paths[i][dd] != ' ')); dd++)
  {
   stop=0;
   for (ddd=0; ((!stop) && (loop_paths[j][ddd] != ' ')); ddd++)
     if (loop_paths[i][dd] == loop_paths[j][ddd])
       stop = 1;

   if ((!stop))
     not_equal = 1;
  }
  if (!not_equal)
    return 1;
  else return 0;
}
int i_adjto_j(idi,idj)
char idi;
char idj;
{
  int id_index,i,j,res1=0,res=0;

  id_index=Find_index(idj);
  for (i=0;i< adj_list[id_index].outdegree;i++)
    if (adj_list[id_index].elements[i] == idi)
      res1 = 1;
  if (res1==1)
    res = 1;

  return res;
}
int loop_matched(i,loop,m)  
int i;
char loop[200];
int m;
{
  int k,l,match=1;

  for (k=0,l=m; loop_paths[i][k] != ' '; k++,l++)
    if (loop_paths[i][k] != loop[l])
      match=0;

  return match;
}
